From 5a23dbcd523ecfa7f595aafc19556e2ae0f123c2 Mon Sep 17 00:00:00 2001
From: Oliver Hader <oliver@typo3.org>
Date: Thu, 2 Jul 2020 12:55:22 +0200
Subject: [PATCH] [SECURITY] Restrict file validation hash generation

Releases: 6.2
Resolves: DEV-564
Security-References: CVE-2020-15086
Change-Id: Ie72bce0f4c131e9c94a2b7375ec901d2959ba1c2
---
 typo3/sysext/cms/tslib/PHP/ValidateHashEID.php | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

diff --git a/typo3/sysext/cms/tslib/PHP/ValidateHashEID.php b/typo3/sysext/cms/tslib/PHP/ValidateHashEID.php
index e2ee58bee..2d15138ec 100644
--- a/typo3/sysext/cms/tslib/PHP/ValidateHashEID.php
+++ b/typo3/sysext/cms/tslib/PHP/ValidateHashEID.php
@@ -14,10 +14,13 @@
 
 call_user_func(function() {
     $value = \TYPO3\CMS\Core\Utility\GeneralUtility::_GET('value');
-    $addition = \TYPO3\CMS\Core\Utility\GeneralUtility::_GET('addition');
     $scope = \TYPO3\CMS\Core\Utility\GeneralUtility::_GET('scope');
 
-    $content = \TYPO3\CMS\Core\Utility\GeneralUtility::hmac($value, $addition);
+    if (!is_string($value) || empty($value)) {
+		\TYPO3\CMS\Core\Utility\HttpUtility::setResponseCodeAndExit(\TYPO3\CMS\Core\Utility\HttpUtility::HTTP_STATUS_400);
+    }
+
+    $content = \TYPO3\CMS\Core\Utility\GeneralUtility::hmac($value, 'flashvars');
 
     if ($scope === 'flashvars') {
         header('Content-type: application/x-www-form-urlencoded');
